unit Depart6;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, extctrls, DIB, DXDraws, DXClass, ComCtrls, Grids;

type
  TForm1 = class(TForm)
    DXDraw1: TDXDraw;
    Label1: TLabel;
    Label2: TLabel;
    SB: TScrollBar;
    AddRed: TRadioButton;
    Label3: TLabel;
    C2: TDXDIB;
    C16: TDXDIB;
    Temp: TDXDIB;
    AddGreen: TRadioButton;
    AddBlue: TRadioButton;
    Restore: TRadioButton;
    Contrast: TRadioButton;
    Saturation: TRadioButton;
    Lightness: TRadioButton;
    Emboss: TRadioButton;
    Sharpen: TRadioButton;
    Spray: TRadioButton;
    Twist: TRadioButton;
    FishEye: TRadioButton;
    GradiantNoise: TRadioButton;
    Blur: TRadioButton;
    MonoNoise: TRadioButton;
    SRW: TRadioButton;
    EF: TRadioButton;
    E3DF: TRadioButton;
    SOF: TRadioButton;
    LF: TRadioButton;
    GF: TRadioButton;
    SF: TRadioButton;
    StatusBar1: TStatusBar;
    C256: TDXDIB;
    C24B: TDXDIB;
    D1: TDXDIB;
    GB: TGroupBox;
    mono: TRadioButton;
    Col16: TRadioButton;
    Col256: TRadioButton;
    Col65000: TRadioButton;
    B24: TRadioButton;
    TC: TRadioButton;
    GS: TRadioButton;
    C32B: TDXDIB;
    C65000: TDXDIB;
    Rotate: TRadioButton;
    SplitBlur: TRadioButton;
    GaussianBlur: TRadioButton;
    procedure DXTimer1Activate(Sender: TObject);
    procedure AddRedClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure SBScroll(Sender: TObject; ScrollCode: TScrollCode;
      var ScrollPos: Integer);
    procedure SBChange(Sender: TObject);
    procedure DXTimer1Timer(Sender: TObject; LagCount: Integer);
    procedure RestoreClick(Sender: TObject);
    procedure ContrastClick(Sender: TObject);
    procedure EmbossClick(Sender: TObject);
    procedure SharpenClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure MosaicClick(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure FishEyeClick(Sender: TObject);
    procedure SRWClick(Sender: TObject);
    procedure EFClick(Sender: TObject);
    procedure E3DFClick(Sender: TObject);
    procedure SOFClick(Sender: TObject);
    procedure LFClick(Sender: TObject);
    procedure GFClick(Sender: TObject);
    procedure SFClick(Sender: TObject);
    procedure ABClick(Sender: TObject);
    procedure SprayClick(Sender: TObject);
    procedure monoClick(Sender: TObject);
    procedure Col16Click(Sender: TObject);
    procedure Col256Click(Sender: TObject);
    procedure B24Click(Sender: TObject);
    procedure SaturationClick(Sender: TObject);
    procedure Col65000Click(Sender: TObject);
    procedure RotateClick(Sender: TObject);
  private
    { dclarations prives }
    bmpdib: TDIB;
    procedure Affiche;
  public
    { dclarations publiques }
  end;
var
  Form1: TForm1;
implementation

{$R *.DFM}

procedure TForm1.DXTimer1Activate(Sender: TObject);
begin
  if not DXDraw1.CanDraw then exit;
  Affiche;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  bmpdib := TDIB.Create;
  Label1.caption := '';
  Label2.Caption := '';
  Label3.Caption := '';
  D1.DIB.Assign(C256.DIB);
  Temp.DIB.Assign(D1.DIB);
  StatusBar1.Panels[0].Text := 'Sunset on St-Gilles fishing port';
end;

procedure TForm1.FormPaint(Sender: TObject);
begin
  Affiche;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  bmpdib.Free;
end;

procedure TForm1.SBScroll(Sender: TObject; ScrollCode: TScrollCode;
  var ScrollPos: Integer);
begin
  Label3.Caption := IntToStr(SB.Position);
  Affiche;
end;

procedure TForm1.SBChange(Sender: TObject);
var
  i: byte;

begin
  if Restore.Checked then
    Temp.DIB.Assign(D1.DIB);
  if Emboss.Checked then
    begin
      Temp.DIB.Assign(D1.DIB);
      Temp.DIB.Emboss;
    end;
  if AddRed.Checked then
    begin
      Temp.DIB.Assign(D1.DIB);
      Temp.DIB.AddRGB(SB.Position,0,0);
    end;
  if AddGreen.Checked then
    begin
      Temp.DIB.Assign(D1.DIB);
      Temp.DIB.AddRGB(0,SB.Position,0);
    end;
  if AddBlue.Checked then
    begin
      Temp.DIB.Assign(D1.DIB);
      Temp.DIB.AddRGB(0,0,SB.Position);
    end;
  if Contrast.Checked then
    begin
      Temp.DIB.Assign(D1.DIB);
      Temp.DIB.Contrast(SB.Position);
    end;
  if Saturation.Checked then
    begin
      Temp.DIB.Assign(D1.DIB);
      Temp.DIB.Saturation(SB.Position);
    end;
  if Lightness.Checked then
    begin
      Temp.DIB.Assign(D1.DIB);
      Temp.DIB.Lightness(SB.Position);
    end;
  if Sharpen.Checked then
    begin
      Temp.DIB.Assign(D1.DIB);
      Temp.DIB.Sharpen(SB.Position);
    end;
  if Twist.Checked then
    begin
      Temp.DIB.Assign(D1.DIB);
      if Temp.DIB.Twist(bmpdib,SB.Position) then
        Temp.DIB.Assign(bmpdib);
    end;
  if Blur.Checked then
    begin
      Temp.DIB.Assign(D1.DIB);
      Temp.DIB.Blur(D1.DIB.BitCount,SB.Position);
    end;
  if SplitBlur.Checked then
    begin
      Temp.DIB.Assign(D1.DIB);
      Temp.DIB.SplitBlur(SB.Position);
    end;
  if GaussianBlur.Checked then
    begin
      Temp.DIB.Assign(D1.DIB);
      Temp.DIB.GaussianBlur(Temp.DIB,SB.Position);
    end;
  if Spray.Checked then
    begin
      Temp.DIB.Assign(D1.DIB);
      Temp.DIB.Spray(SB.Position);
    end;
  if FishEye.Checked then
    begin
      Temp.DIB.Assign(D1.DIB);
      if Temp.DIB.FishEye(bmpdib) then
        Temp.DIB.Assign(bmpdib);
    end;
  if GradiantNoise.Checked then
    begin
      Temp.DIB.Assign(D1.DIB);
      Temp.DIB.AddGradiantNoise(SB.Position);
    end;
  if MonoNoise.Checked then
    begin
      Temp.DIB.Assign(D1.DIB);
      Temp.DIB.AddMonoNoise(SB.Position);
    end;
  if SRW.Checked then
    begin
      Temp.DIB.Assign(D1.DIB);
      if Temp.DIB.SmoothRotateWrap(bmpdib,(bmpDib.Width div 2),(bmpdib.Height div 2),SB.Position) then
        Temp.DIB.Assign(bmpdib);
    end;
  if Rotate.Checked then
    begin
      Temp.DIB.Assign(D1.DIB);
      if Temp.DIB.Rotate(bmpdib,(bmpDib.Width div 2),(bmpdib.Height div 2),SB.Position) then
        Temp.DIB.Assign(bmpdib);
    end;
  if GS.Checked then
    begin
      Temp.DIB.Assign(D1.DIB);
      Temp.DIB.GreyScale(D1.DIB.BitCount);
    end;
end;

procedure TForm1.Affiche;
begin
  DXDraw1.Surface.Canvas.StretchDraw(Bounds(0,0,DXDraw1.Width,DXDraw1.Height),Temp.DIB);
  DXDraw1.Surface.Canvas.Release;
  DXDraw1.Flip;
end;

procedure TForm1.monoClick(Sender: TObject);
begin
  D1.DIB.Assign(C2.DIB);
  Affiche;
  SBChange(Sender);
  Affiche;
  StatusBar1.Panels[0].Text := 'Boucan Canot''s beach (my garden !)';
end;

procedure TForm1.Col16Click(Sender: TObject);
begin
  D1.DIB.Assign(C16.DIB);
  Affiche;
  SBChange(Sender);
  Affiche;
  StatusBar1.Panels[0].Text := 'A beautiful creole house';
end;

procedure TForm1.Col256Click(Sender: TObject);
begin
  D1.DIB.Assign(C256.DIB);
  Affiche;
  SBChange(Sender);
  Affiche;
  StatusBar1.Panels[0].Text := 'Sunset on St-Gilles fishing port';
end;

procedure TForm1.Col65000Click(Sender: TObject);
begin
  D1.DIB.Assign(C65000.DIB);
  Affiche;
  SBChange(Sender);
  Affiche;
  StatusBar1.Panels[0].Text := 'Artificial bitmap';
end;

procedure TForm1.B24Click(Sender: TObject);
begin
  D1.DIB.Assign(C24B.DIB);
  Affiche;
  SBChange(Sender);
  Affiche;
  StatusBar1.Panels[0].Text := 'My girl : Yvanna';
end;

procedure TForm1.DXTimer1Timer(Sender: TObject; LagCount: Integer);
begin
  Affiche;
end;

procedure TForm1.AddRedClick(Sender: TObject);
begin
  Label1.Caption := '0';
  Label2.Caption := '255';
  Label3.Caption := '0';
  SB.Min := 0;
  SB.Max := 255;
  SB.Position := 0;
  SBChange(Sender);
  Affiche;
end;

procedure TForm1.RestoreClick(Sender: TObject);
begin
  Temp.DIB.Assign(D1.DIB);
  Label1.Caption := '';
  Label2.Caption := '';
  Label3.Caption := '';
  Affiche;
end;

procedure TForm1.ContrastClick(Sender: TObject);
begin
  Label1.Caption := '-255';
  Label2.Caption := '255';
  Label3.Caption := '0';
  SB.Min := -255;
  SB.Max := 255;
  SB.Position := 0;
  SBChange(Sender);
  Affiche;
end;

procedure TForm1.SaturationClick(Sender: TObject);
begin
  Label1.Caption := '0';
  Label2.Caption := '510';
  Label3.Caption := '255';
  SB.Min := 0;
  SB.Max := 510;
  SB.Position := 255;
  SBChange(Sender);
  Affiche;
end;

procedure TForm1.EmbossClick(Sender: TObject);
begin
  Label1.Caption := '';
  Label2.Caption := '';
  Label3.Caption := '';
  SBChange(Sender);
  Affiche;
end;

procedure TForm1.SharpenClick(Sender: TObject);
begin
  Label1.Caption := '0';
  Label2.Caption := '255';
  Label3.Caption := '0';
  SB.Min := 0;
  SB.Max := 255;
  SB.Position := 0;
  bmpdib.SetSize(D1.DIB.Width,D1.DIB.Height,D1.DIB.BitCount);
  SBChange(Sender);
  Affiche;
end;

procedure TForm1.MosaicClick(Sender: TObject);
begin
  Label1.Caption := '0';
  Label2.Caption := '255';
  Label3.Caption := '0';
  SB.Min := 0;
  SB.Max := 255;
  SB.Position := 0;
  SBChange(Sender);
  Affiche;
end;

procedure TForm1.FishEyeClick(Sender: TObject);
begin
  Label1.Caption := '0';
  Label2.Caption := '255';
  Label3.Caption := '0';
  SB.Min := 0;
  SB.Max := 255;
  SB.Position := 0;
  bmpdib.SetSize(D1.DIB.Width,D1.DIB.Height,D1.DIB.BitCount);
  SBChange(Sender);
  Affiche;
end;

procedure TForm1.SRWClick(Sender: TObject);
begin
  Label1.Caption := '0';
  Label2.Caption := '255';
  Label3.Caption := '0';
  SB.Min := 0;
  SB.Max := 255;
  SB.Position := 0;
  bmpdib.SetSize(D1.DIB.Width,D1.DIB.Height,D1.DIB.BitCount);
  SBChange(Sender);
  Affiche;
end;

procedure TForm1.EFClick(Sender: TObject);
begin
  Label1.Caption := '';
  Label2.Caption := '';
  Label3.Caption := '';
  Temp.DIB.Assign(D1.DIB);
  bmpdib.SetSize(D1.DIB.Width,D1.DIB.Height,D1.DIB.BitCount);
  Temp.DIB.Filter(bmpdib, EdgeFilter);
  Temp.DIB.Assign(bmpdib);
  Affiche;
end;

procedure TForm1.E3DFClick(Sender: TObject);
begin
  Label1.Caption := '';
  Label2.Caption := '';
  Label3.Caption := '';
  Temp.DIB.Assign(D1.DIB);
  bmpdib.SetSize(D1.DIB.Width,D1.DIB.Height,D1.DIB.BitCount);
  Temp.DIB.Filter(bmpdib, Enhance3DFilter);
  Temp.DIB.Assign(bmpdib);
  Affiche;
end;

procedure TForm1.SOFClick(Sender: TObject);
begin
  Label1.Caption := '';
  Label2.Caption := '';
  Label3.Caption := '';
  Temp.DIB.Assign(D1.DIB);
  bmpdib.SetSize(D1.DIB.Width,D1.DIB.Height,D1.DIB.BitCount);
  Temp.DIB.Filter(bmpdib, StrongOutlineFilter);
  Temp.DIB.Assign(bmpdib);
  Affiche;
end;

procedure TForm1.LFClick(Sender: TObject);
begin
  Label1.Caption := '';
  Label2.Caption := '';
  Label3.Caption := '';
  Temp.DIB.Assign(D1.DIB);
  bmpdib.SetSize(D1.DIB.Width,D1.DIB.Height,D1.DIB.BitCount);
  Temp.DIB.Filter(bmpdib, LinearFilter);
  Temp.DIB.Assign(bmpdib);
  Affiche;
end;

procedure TForm1.GFClick(Sender: TObject);
begin
  Label1.Caption := '';
  Label2.Caption := '';
  Label3.Caption := '';
  Temp.DIB.Assign(D1.DIB);
  bmpdib.SetSize(D1.DIB.Width,D1.DIB.Height,D1.DIB.BitCount);
  Temp.DIB.Filter(bmpdib, GranularFilter);
  Temp.DIB.Assign(bmpdib);
  Affiche;
end;

procedure TForm1.SFClick(Sender: TObject);
begin
  Label1.Caption := '';
  Label2.Caption := '';
  Label3.Caption := '';
  Temp.DIB.Assign(D1.DIB);
  bmpdib.SetSize(D1.DIB.Width,D1.DIB.Height,D1.DIB.BitCount);
  Temp.DIB.Filter(bmpdib, SharpFilter);
  Temp.DIB.Assign(bmpdib);
  Affiche;
end;

procedure TForm1.ABClick(Sender: TObject);
begin
  Label1.Caption := '0';
  Label2.Caption := '255';
  Label3.Caption := '0';
  SB.Min := 0;
  SB.Max := 255;
  SB.Position := 0;
  SBChange(Sender);
  Affiche;
end;

procedure TForm1.SprayClick(Sender: TObject);
begin
  Label1.Caption := '0';
  Label2.Caption := '255';
  Label3.Caption := '0';
  SB.Min := 0;
  SB.Max := 255;
  SB.Position := 0;
  bmpdib.SetSize(D1.DIB.Width,D1.DIB.Height,D1.DIB.BitCount);
  SBChange(Sender);
  Affiche;
end;

procedure TForm1.RotateClick(Sender: TObject);
begin
  Label1.Caption := '0';
  Label2.Caption := '255';
  Label3.Caption := '0';
  SB.Min := 0;
  SB.Max := 255;
  SB.Position := 0;
  bmpdib.SetSize(D1.DIB.Width,D1.DIB.Height,D1.DIB.BitCount);
  SBChange(Sender);
  Affiche;
end;

end.
