unit GUIWindow;

interface

uses 
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  DXGUI, DXGUIClasses;

type
  TDXWindowFrame = class(TFrame)
    DXWindow: TDXContainer;
  Protected
    { Protected declarations }
    // Pointer to the base of the GUI
    fDXDrawGUI : TDXDrawGUI;
    fPrimaryContainer : TCustomDXContainer;
    Procedure SetDXDrawGUI(ADXDrawGUI: TDXDrawGUI); virtual;
    Procedure SetPrimaryContainer(APrimaryContainer: TCustomDXContainer); virtual;
  public
    { Public declarations }
    AutoLatch : boolean;
    // this provides the DXDraw object, if PrimaryContainer is nil then
    // the PrimaryContainer is set to DXDrawGUI.DXControlContainer
    // bu only if AutoLatch is set.
    Property DXDrawGUI  : TDXDrawGUI read fDXDrawGUI write SetDXDrawGUI;
    // Provides the container the GUI tree is to be inserted into
    Property PrimaryContainer : TCustomDXContainer read fPrimaryContainer write SetPrimaryContainer;
  end;
  
implementation

{$R *.DFM}

// -----------------------------------------------------------------------------
//  TDXWindowFrame
// -----------------------------------------------------------------------------
Procedure TDXWindowFrame.SetDXDrawGUI(ADXDrawGUI: TDXDrawGUI);
var
 pos : Tpoint;
begin
if fDXDrawGUI <> ADXDrawGUI then
  begin
  fDXDrawGUI := ADXDrawGUI;
  Parent := fDXDrawGUI;
  DXWindow.DXDrawGUI := fDXDrawGUI;
  if (DXWindow <> nil) and (DXWindow <> nil) then
    begin
    pos := DXWindow.ScreenToClient(fDXDrawGUI.ClientToScreen(point(0,0)));
    left := pos.x;
    top := pos.y;
    end;
  if AutoLatch and (fDXDrawGUI <> nil) and (fPrimaryContainer = nil) then
    PrimaryContainer := fDXDrawGUI.DXControlContainer;
  end;
end; {SetDXDrawGUI}

Procedure TDXWindowFrame.SetPrimaryContainer(APrimaryContainer: TCustomDXContainer);
begin
if fPrimaryContainer <> APrimaryContainer then
  begin
  fPrimaryContainer := APrimaryContainer;
  DXWindow.DXContainer := fPrimaryContainer;
  end;
end; {SetPrimaryContainer}

end.
