unit Test;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,extctrls;

type
  TTest = class(Timage)
  private
    { Private declarations }
  protected
    { Protected declarations }
    procedure WndProc(var Message: TMessage); override;
    
  public
    { Public declarations }

  published
    { Published declarations }
  end;
procedure Register;

implementation
uses Debugsubsystem;


function MsgType(const Message: TMessage) : string;
begin
case Message.Msg of
  CM_ACTIVATE  : result := 'CM_ACTIVATE';
  CM_DEACTIVATE: result := 'CM_DEACTIVATE';
  CM_GOTFOCUS: result := 'CM_GOTFOCUS';
  CM_LOSTFOCUS: result := 'CM_LOSTFOCUS';
  CM_CANCELMODE: result := 'CM_CANCELMODE';
  CM_DIALOGKEY: result := 'CM_DIALOGKEY';
  CM_DIALOGCHAR: result := 'CM_DIALOGCHAR';
  CM_FOCUSCHANGED: result := 'CM_FOCUSCHANGED';
  CM_PARENTFONTCHANGED: result := 'CM_PARENTFONTCHANGED';
  CM_PARENTCOLORCHANGED: result := 'CM_PARENTCOLORCHANGED';
  CM_HITTEST: result := 'CM_HITTEST';
  CM_VISIBLECHANGED: result := 'CM_VISIBLECHANGED';
  CM_ENABLEDCHANGED: result := 'CM_ENABLEDCHANGED';
  CM_COLORCHANGED : result := 'CM_COLORCHANGED';
  CM_FONTCHANGED : result := 'CM_FONTCHANGED';
  CM_CURSORCHANGED : result := 'CM_CURSORCHANGED';
  CM_CTL3DCHANGED : result := 'CM_CTL3DCHANGED';
  CM_PARENTCTL3DCHANGED : result := 'CM_PARENTCTL3DCHANGED';
  CM_TEXTCHANGED : result := 'CM_TEXTCHANGED';
  CM_MOUSEENTER : result := 'CM_MOUSEENTER';
  CM_MOUSELEAVE : result := 'CM_MOUSELEAVE';
  CM_MENUCHANGED : result := 'CM_MENUCHANGED';
  CM_APPKEYDOWN : result := 'CM_APPKEYDOWN';
  CM_APPSYSCOMMAND : result := 'CM_APPSYSCOMMAND';
  CM_BUTTONPRESSED : result := 'CM_BUTTONPRESSED';
  CM_SHOWINGCHANGED : result := 'CM_SHOWINGCHANGED';
  CM_ENTER : result := 'CM_ENTER';
  CM_EXIT : result := 'CM_EXIT';
  CM_DESIGNHITTEST : result := 'CM_DESIGNHITTEST';
  CM_ICONCHANGED : result := 'CM_ICONCHANGED';
  CM_WANTSPECIALKEY : result := 'CM_WANTSPECIALKEY';
  CM_INVOKEHELP : result := 'CM_INVOKEHELP';
  CM_WINDOWHOOK : result := 'CM_WINDOWHOOK';
  CM_RELEASE : result := 'CM_RELEASE';
  CM_SHOWHINTCHANGED : result := 'CM_SHOWHINTCHANGED';
  CM_PARENTSHOWHINTCHANGED : result := 'CM_PARENTSHOWHINTCHANGED';
  CM_SYSCOLORCHANGE : result := 'CM_SYSCOLORCHANGE';
  CM_WININICHANGE : result := 'CM_WININICHANGE';
  CM_FONTCHANGE : result := 'CM_FONTCHANGE';
  CM_TIMECHANGE : result := 'CM_TIMECHANGE';
  CM_TABSTOPCHANGED : result := 'CM_TABSTOPCHANGED';
  CM_UIACTIVATE : result := 'CM_UIACTIVATE';
  CM_UIDEACTIVATE : result := 'CM_UIDEACTIVATE';
  CM_DOCWINDOWACTIVATE : result := 'CM_DOCWINDOWACTIVATE';
  CM_CONTROLLISTCHANGE : result := 'CM_CONTROLLISTCHANGE';
  CM_GETDATALINK : result := 'CM_GETDATALINK';
  CM_CHILDKEY : result := 'CM_CHILDKEY';
  CM_DRAG : result := 'CM_DRAG';
  CM_HINTSHOW : result := 'CM_HINTSHOW';
  CM_DIALOGHANDLE : result := 'CM_DIALOGHANDLE';
  CM_ISTOOLCONTROL                : result := 'CM_ISTOOLCONTROL';
  CM_RECREATEWND : result := 'CM_RECREATEWND';
  CM_INVALIDATE : result := 'CM_INVALIDATE';
  CM_SYSFONTCHANGED : result := 'CM_SYSFONTCHANGED';
  CM_CONTROLCHANGE : result := 'CM_CONTROLCHANGE';
  CM_CHANGED : result := 'CM_CHANGED';
  CM_DOCKCLIENT : result := 'CM_DOCKCLIENT';
  CM_UNDOCKCLIENT : result := 'CM_UNDOCKCLIENT';
  CM_FLOAT : result := 'CM_FLOAT';
  CM_BORDERCHANGED : result := 'CM_BORDERCHANGED';
  CM_BIDIMODECHANGED : result := 'CM_BIDIMODECHANGED';
  CM_PARENTBIDIMODECHANGED : result := 'CM_PARENTBIDIMODECHANGED';
  CM_ALLCHILDRENFLIPPED : result := 'CM_ALLCHILDRENFLIPPED';
  CM_ACTIONUPDATE : result := 'CM_ACTIONUPDATE';
  CM_ACTIONEXECUTE : result := 'CM_ACTIONEXECUTE';
  CM_HINTSHOWPAUSE : result := 'CM_HINTSHOWPAUSE';
  CM_DOCKNOTIFICATION : result := 'CM_DOCKNOTIFICATION';
  CM_MOUSEWHEEL : result := 'CM_MOUSEWHEEL';

else
 result := 'Unknown. Msg Id = '+ IntToHex(Message.Msg,4);
end;
end;

procedure TTest.WndProc(var Message: TMessage);
begin
// we add this so we can analize all the msgs that are
// send to a TCustomDXControl
if (csDesigning in ComponentState)  then
  begin
  LogAction(MsgType(Message));
  end;
// Very important, call the default handler
Inherited WndProc(Message);
end; {WndProc}

procedure Register;
begin
  RegisterComponents('Standard', [TTest]);
end;

initialization 
// This makes sure the log file is set up
debug_setup;
end.
 